#ifndef _TIME_H
#define _TIME_H
/* ---------------------------------------------------------------------------- */

//! Define system HZ
#define HZ 1000

//!Time def
typedef unsigned long tick_t;

/* ---------------------------------------------------------------------------- */

//! Initialize the system timer
void time_init();

/* ---------------------------------------------------------------------------- */

tick_t read_tick(void);


/* ---------------------------------------------------------------------------- */
//! Check for timer elapsed
static inline int timer_elapsed(tick_t t1, tick_t timeout)
{
        tick_t t2 = read_tick();
        if( t2 >= t1)   //Not overflow
            return t2 - t1 > timeout;
        else      //Overflow
            return t1 - t2 > timeout;
}
/* ---------------------------------------------------------------------------- */
static inline void wait_ms(tick_t timeout)
{
    tick_t now = read_tick();
    while( !timer_elapsed(now,timeout) );
}

/* ---------------------------------------------------------------------------- */
#endif

